## openblas 0.3.8+ds

=== CMakeLists.txt ===
##
## Author: Hank Anderson <hank@statease.com>
##

cmake_minimum_required(VERSION 2.8.5)
project(OpenBLAS C ASM)
set(OpenBLAS_MAJOR_VERSION 0)
set(OpenBLAS_MINOR_VERSION 3)
set(OpenBLAS_PATCH_VERSION 8)
set(OpenBLAS_VERSION "${OpenBLAS_MAJOR_VERSION}.${OpenBLAS_MINOR_VERSION}.${OpenBLAS_PATCH_VERSION}")

# Adhere to GNU filesystem layout conventions
include(GNUInstallDirs)

include(CMakePackageConfigHelpers)


#######
if(MSVC)
option(BUILD_WITHOUT_LAPACK "Do not build LAPACK and LAPACKE (Only BLAS or CBLAS)" ON)
endif()
option(BUILD_WITHOUT_CBLAS "Do not build the C interface (CBLAS) to the BLAS functions" OFF)
option(DYNAMIC_ARCH "Include support for multiple CPU targets, with automatic selection at runtime (x86/x86_64, aarch64 or ppc only)" OFF)
option(DYNAMIC_OLDER "Include specific support for older x86 cpu models (Penryn,Dunnington,Atom,Nano,Opteron) with DYNAMIC_ARCH" OFF)
option(BUILD_RELAPACK "Build with ReLAPACK (recursive implementation of several LAPACK functions on top of standard LAPACK)" OFF)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
option(NO_AFFINITY "Disable support for CPU affinity masks to avoid binding processes from e.g. R or numpy/scipy to a single core" ON)
else()
set(NO_AFFINITY 1)
endif()

# Add a prefix or suffix to all exported symbol names in the shared library.
# Avoids conflicts with other BLAS libraries, especially when using
# 64 bit integer interfaces in OpenBLAS.

set(SYMBOLPREFIX "" CACHE STRING  "Add a prefix to all exported symbol names in the shared library to avoid conflicts with other BLAS libraries" )
set(SYMBOLSUFFIX "" CACHE STRING  "Add a suffix to all exported symbol names in the shared library, e.g. _64 for INTERFACE64 builds" )
#######
if(BUILD_WITHOUT_LAPACK)
set(NO_LAPACK 1)
set(NO_LAPACKE 1)
endif()

if(BUILD_WITHOUT_CBLAS)
set(NO_CBLAS 1)
endif()

#######

if(MSVC AND MSVC_STATIC_CRT)
    set(CompilerFlags
            CMAKE_CXX_FLAGS
            CMAKE_CXX_FLAGS_DEBUG
            CMAKE_CXX_FLAGS_RELEASE
            CMAKE_C_FLAGS
            CMAKE_C_FLAGS_DEBUG
            CMAKE_C_FLAGS_RELEASE
            )
    foreach(CompilerFlag ${CompilerFlags})
      string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
    endforeach()
endif()

message(WARNING "CMake support is experimental. It does not yet support all build options and may not produce the same Makefiles that OpenBLAS ships with.")

include("${PROJECT_SOURCE_DIR}/cmake/utils.cmake")
include("${PROJECT_SOURCE_DIR}/cmake/system.cmake")

set(OpenBLAS_LIBNAME openblas${SUFFIX64_UNDERSCORE})

set(BLASDIRS interface driver/level2 driver/level3 driver/others)

if (NOT DYNAMIC_ARCH)
  list(APPEND BLASDIRS kernel)
endif ()

if (DEFINED SANITY_CHECK)
  list(APPEND BLASDIRS reference)
endif ()

set(SUBDIRS	${BLASDIRS})
if (NOT NO_LAPACK)
  if(BUILD_RELAPACK)
    list(APPEND SUBDIRS relapack/src)
  endif()
  list(APPEND SUBDIRS lapack)
endif ()

# set which float types we want to build for
if (NOT DEFINED BUILD_SINGLE AND NOT DEFINED BUILD_DOUBLE AND NOT DEFINED BUILD_COMPLEX AND NOT DEFINED BUILD_COMPLEX16)
  # if none are defined, build for all
  set(BUILD_SINGLE true)
  set(BUILD_DOUBLE true)
  set(BUILD_COMPLEX true)
  set(BUILD_COMPLEX16 true)
endif ()

if (NOT DEFINED BUILD_MATGEN)
  set(BUILD_MATGEN true)
endif()

set(FLOAT_TYPES "")
if (BUILD_SINGLE)
  message(STATUS "Building Single Precision")
  list(APPEND FLOAT_TYPES "SINGLE") # defines nothing
endif ()

if (BUILD_DOUBLE)
  message(STATUS "Building Double Precision")
  list(APPEND FLOAT_TYPES "DOUBLE") # defines DOUBLE
endif ()

if (BUILD_COMPLEX)
  message(STATUS "Building Complex Precision")
  list(APPEND FLOAT_TYPES "COMPLEX") # defines COMPLEX
endif ()

if (BUILD_COMPLEX16)
  message(STATUS "Building Double Complex Precision")
  list(APPEND FLOAT_TYPES "ZCOMPLEX") # defines COMPLEX and DOUBLE
endif ()

if (NOT DEFINED CORE OR "${CORE}" STREQUAL "UNKNOWN")
  message(FATAL_ERROR "Detecting CPU failed. Please set TARGET explicitly, e.g. make TARGET=your_cpu_target. Please read README for details.")
endif ()

#Set default output directory
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
if(MSVC)
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG ${PROJECT_BINARY_DIR}/lib/Debug)
set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${PROJECT_BINARY_DIR}/lib/Release)
endif ()
# get obj vars into format that add_library likes: $<TARGET_OBJS:objlib> (see http://www.cmake.org/cmake/help/v3.0/command/add_library.html)
set(TARGET_OBJS "")
foreach (SUBDIR ${SUBDIRS})
  add_subdirectory(${SUBDIR})
  string(REPLACE "/" "_" subdir_obj ${SUBDIR})
  list(APPEND TARGET_OBJS "$<TARGET_OBJECTS:${subdir_obj}>")
endforeach ()

# netlib:

# Can't just use lapack-netlib's CMake files, since they are set up to search for BLAS, build and install a binary. We just want to build a couple of lib files out of lapack and lapacke.
# Not using add_subdirectory here because lapack-netlib already has its own CMakeLists.txt. Instead include a cmake script with the sources we want.
if (NOT NOFORTRAN AND NOT NO_LAPACK)
  include("${PROJECT_SOURCE_DIR}/cmake/lapack.cmake")
  if (NOT NO_LAPACKE)
    include("${PROJECT_SOURCE_DIR}/cmake/lapacke.cmake")
  endif ()
endif ()

# Only generate .def for dll on MSVC and always produce pdb files for debug and release
if(MSVC)
  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_LESS 3.4)
    set(OpenBLAS_DEF_FILE "${PROJECT_BINARY_DIR}/openblas.def")
  endif()
  set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Zi")
  set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
endif()

if (${DYNAMIC_ARCH})
  add_subdirectory(kernel)
  foreach(TARGET_CORE ${DYNAMIC_CORE})
    message("${TARGET_CORE}")
    list(APPEND TARGET_OBJS "$<TARGET_OBJECTS:kernel_${TARGET_CORE}>")
  endforeach()
endif ()

# add objects to the openblas lib
add_library(${OpenBLAS_LIBNAME} ${LA_SOURCES} ${LAPACKE_SOURCES} ${RELA_SOURCES} ${TARGET_OBJS} ${OpenBLAS_DEF_FILE})
target_include_directories(${OpenBLAS_LIBNAME} INTERFACE $<INSTALL_INTERFACE:include/openblas${SUFFIX64}>)

# Android needs to explicitly link against libm
if(ANDROID)
  target_link_libraries(${OpenBLAS_LIBNAME} m)
endif()

# Handle MSVC exports
if(MSVC AND BUILD_SHARED_LIBS)
  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_LESS 3.4)
    include("${PROJECT_SOURCE_DIR}/cmake/export.cmake")
  else()
    # Creates verbose .def file (51KB vs 18KB)
    set_target_properties(${OpenBLAS_LIBNAME} PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS true)
  endif()
endif()

# Set output for libopenblas
set_target_properties( ${OpenBLAS_LIBNAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set_target_properties( ${OpenBLAS_LIBNAME} PROPERTIES LIBRARY_OUTPUT_NAME_DEBUG "${OpenBLAS_LIBNAME}_d")
set_target_properties( ${OpenBLAS_LIBNAME} PROPERTIES EXPORT_NAME "OpenBLAS")

foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
  string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )

  set_target_properties( ${OpenBLAS_LIBNAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_BINARY_DIR}/lib/${OUTPUTCONFIG} )
  set_target_properties( ${OpenBLAS_LIBNAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_BINARY_DIR}/lib/${OUTPUTCONFIG} )
  set_target_properties( ${OpenBLAS_LIBNAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_BINARY_DIR}/lib/${OUTPUTCONFIG} )
endforeach()

enable_testing()

if (USE_THREAD)
  # Add threading library to linker
  find_package(Threads)
  if (THREADS_HAVE_PTHREAD_ARG)
    set_property(TARGET ${OpenBLAS_LIBNAME} PROPERTY COMPILE_OPTIONS "-pthread")
    set_property(TARGET ${OpenBLAS_LIBNAME} PROPERTY INTERFACE_COMPILE_OPTIONS "-pthread")
  endif()
  target_link_libraries(${OpenBLAS_LIBNAME} ${CMAKE_THREAD_LIBS_INIT})
endif()

#if (MSVC OR NOT NOFORTRAN)
if (NOT NO_CBLAS)
  # Broken without fortran on unix
  add_subdirectory(utest)
endif()

if (NOT MSVC AND NOT NOFORTRAN)
  # Build test and ctest
  add_subdirectory(test)
  if(NOT NO_CBLAS)
    add_subdirectory(ctest)
  endif()
endif()

set_target_properties(${OpenBLAS_LIBNAME} PROPERTIES
  VERSION ${OpenBLAS_MAJOR_VERSION}.${OpenBLAS_MINOR_VERSION}
  SOVERSION ${OpenBLAS_MAJOR_VERSION}
)

if (BUILD_SHARED_LIBS AND BUILD_RELAPACK)
  if (NOT MSVC)
    target_link_libraries(${OpenBLAS_LIBNAME} "-Wl,-allow-multiple-definition")
  else()
    target_link_libraries(${OpenBLAS_LIBNAME} "/FORCE:MULTIPLE")
  endif()
endif()

if (BUILD_SHARED_LIBS AND NOT ${SYMBOLPREFIX}${SYMBOLSUFIX} STREQUAL "")
if (NOT DEFINED ARCH)
  set(ARCH_IN "x86_64")
else()
  set(ARCH_IN ${ARCH})
endif()

if (${CORE} STREQUAL "generic")
  set(ARCH_IN "GENERIC")
endif ()

if (NOT DEFINED EXPRECISION)
  set(EXPRECISION_IN 0)
else()
  set(EXPRECISION_IN ${EXPRECISION})
endif()

if (NOT DEFINED NO_CBLAS)
  set(NO_CBLAS_IN 0)
else()
  set(NO_CBLAS_IN ${NO_CBLAS})
endif()

if (NOT DEFINED NO_LAPACK)
  set(NO_LAPACK_IN 0)
else()
  set(NO_LAPACK_IN ${NO_LAPACK})
endif()

if (NOT DEFINED NO_LAPACKE)
  set(NO_LAPACKE_IN 0)
else()
  set(NO_LAPACKE_IN ${NO_LAPACKE})
endif()

if (NOT DEFINED NEED2UNDERSCORES)
  set(NEED2UNDERSCORES_IN 0)
else()
  set(NEED2UNDERSCORES_IN ${NEED2UNDERSCORES})
endif()

if (NOT DEFINED ONLY_CBLAS)
  set(ONLY_CBLAS_IN 0)
else()
  set(ONLY_CBLAS_IN ${ONLY_CBLAS})
endif()

if (NOT DEFINED BU)
  set(BU _)
endif()

if (NOT ${SYMBOLPREFIX} STREQUAL "")
message(STATUS "adding prefix ${SYMBOLPREFIX} to names of exported symbols in ${OpenBLAS_LIBNAME}")
endif()
if (NOT ${SYMBOLSUFFIX} STREQUAL "")
message(STATUS "adding suffix ${SYMBOLSUFFIX} to names of exported symbols in ${OpenBLAS_LIBNAME}")
endif()
	add_custom_command(TARGET ${OpenBLAS_LIBNAME} POST_BUILD
  	COMMAND perl  ${PROJECT_SOURCE_DIR}/exports/gensymbol "objcopy" "${ARCH}" "${BU}" "${EXPRECISION_IN}" "${NO_CBLAS_IN}" "${NO_LAPACK_IN}" "${NO_LAPACKE_IN}" "${NEED2UNDERSCORES_IN}" "${ONLY_CBLAS_IN}" \"${SYMBOLPREFIX}\" \"${SYMBOLSUFFIX}\" "${BUILD_LAPACK_DEPRECATED}" > ${PROJECT_BINARY_DIR}/objcopy.def
        COMMAND objcopy -v --redefine-syms ${PROJECT_BINARY_DIR}/objcopy.def  ${PROJECT_BINARY_DIR}/lib/lib${OpenBLAS_LIBNAME}.so
        COMMENT "renaming symbols"
        )
endif()


# Install project

# Install libraries
install(TARGETS ${OpenBLAS_LIBNAME}
	EXPORT "OpenBLAS${SUFFIX64}Targets"
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )

# Install headers
set(CMAKE_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR}/openblas${SUFFIX64})
set(CMAKE_INSTALL_FULL_INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})

message(STATUS "Generating openblas_config.h in ${CMAKE_INSTALL_INCLUDEDIR}")

set(OPENBLAS_CONFIG_H ${CMAKE_BINARY_DIR}/openblas_config.h)
file(WRITE  ${OPENBLAS_CONFIG_H} "#ifndef OPENBLAS_CONFIG_H\n")
file(APPEND ${OPENBLAS_CONFIG_H} "#define OPENBLAS_CONFIG_H\n")
file(STRINGS ${PROJECT_BINARY_DIR}/config.h __lines)
foreach(line ${__lines})
  string(REPLACE "#define " "" line ${line})
  file(APPEND ${OPENBLAS_CONFIG_H} "#define OPENBLAS_${line}\n")
endforeach()
file(APPEND ${OPENBLAS_CONFIG_H} "#define OPENBLAS_VERSION \"OpenBLAS ${OpenBLAS_VERSION}\"\n")
file(READ   ${CMAKE_CURRENT_SOURCE_DIR}/openblas_config_template.h OPENBLAS_CONFIG_TEMPLATE_H_CONTENTS)
file(APPEND ${OPENBLAS_CONFIG_H} "${OPENBLAS_CONFIG_TEMPLATE_H_CONTENTS}\n")
file(APPEND ${OPENBLAS_CONFIG_H} "#endif /* OPENBLAS_CONFIG_H */\n")
install (FILES ${OPENBLAS_CONFIG_H} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if(NOT NOFORTRAN)
  message(STATUS "Generating f77blas.h in ${CMAKE_INSTALL_INCLUDEDIR}")

  set(F77BLAS_H ${CMAKE_BINARY_DIR}/generated/f77blas.h)
  file(WRITE  ${F77BLAS_H} "#ifndef OPENBLAS_F77BLAS_H\n")
  file(APPEND ${F77BLAS_H} "#define OPENBLAS_F77BLAS_H\n")
  file(APPEND ${F77BLAS_H} "#include \"openblas_config.h\"\n")
  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/common_interface.h COMMON_INTERFACE_H_CONTENTS)

=== cpp_thread_test/Makefile ===
include ../Makefile.rule

all :: dgemv_tester dgemm_tester

dgemv_tester :
	$(CXX) $(COMMON_OPT) -Wall -Wextra -Wshadow -fopenmp -std=c++11 dgemv_thread_safety.cpp ../libopenblas.a -lpthread -o dgemv_tester
	./dgemv_tester

dgemm_tester : dgemv_tester
	$(CXX) $(COMMON_OPT) -Wall -Wextra -Wshadow -fopenmp -std=c++11 dgemm_thread_safety.cpp ../libopenblas.a -lpthread -o dgemm_tester
	./dgemm_tester

clean ::
	rm -f dgemv_tester dgemm_tester

=== ctest/Makefile ===
#
# The Makefile compiles c wrappers and testers for CBLAS.
#

TOPDIR = ..
include $(TOPDIR)/Makefile.system

override CFLAGS += -DADD$(BU) -DCBLAS
override TARGET_ARCH=
override TARGET_MACH=

LIB = $(TOPDIR)/$(LIBNAME)

stestl1o = c_sblas1.o

stestl2o = c_sblas2.o c_s2chke.o auxiliary.o c_xerbla.o constant.o

stestl3o = c_sblas3.o c_s3chke.o auxiliary.o c_xerbla.o constant.o

dtestl1o = c_dblas1.o

dtestl2o = c_dblas2.o c_d2chke.o auxiliary.o c_xerbla.o constant.o

dtestl3o = c_dblas3.o c_d3chke.o auxiliary.o c_xerbla.o constant.o

ctestl1o = c_cblas1.o

ctestl2o = c_cblas2.o c_c2chke.o auxiliary.o c_xerbla.o constant.o

ctestl3o = c_cblas3.o c_c3chke.o auxiliary.o c_xerbla.o constant.o

ctestl3o_3m = c_cblas3_3m.o c_c3chke_3m.o auxiliary.o c_xerbla.o constant.o

ztestl1o = c_zblas1.o

ztestl2o = c_zblas2.o c_z2chke.o auxiliary.o c_xerbla.o constant.o

ztestl3o = c_zblas3.o c_z3chke.o auxiliary.o c_xerbla.o constant.o

ztestl3o_3m = c_zblas3_3m.o c_z3chke_3m.o auxiliary.o c_xerbla.o constant.o



all :: all1 all2 all3

all1: xscblat1 xdcblat1 xccblat1 xzcblat1
ifndef CROSS
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./xscblat1
	OMP_NUM_THREADS=2 ./xdcblat1
	OMP_NUM_THREADS=2 ./xccblat1
	OMP_NUM_THREADS=2 ./xzcblat1
else
	OPENBLAS_NUM_THREADS=2 ./xscblat1
	OPENBLAS_NUM_THREADS=2 ./xdcblat1
	OPENBLAS_NUM_THREADS=2 ./xccblat1
	OPENBLAS_NUM_THREADS=2 ./xzcblat1
endif
endif

all2: xscblat2 xdcblat2 xccblat2 xzcblat2
ifndef CROSS
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./xscblat2 < sin2
	OMP_NUM_THREADS=2 ./xdcblat2 < din2
	OMP_NUM_THREADS=2 ./xccblat2 < cin2
	OMP_NUM_THREADS=2 ./xzcblat2 < zin2
else
	OPENBLAS_NUM_THREADS=2 ./xscblat2 < sin2
	OPENBLAS_NUM_THREADS=2 ./xdcblat2 < din2
	OPENBLAS_NUM_THREADS=2 ./xccblat2 < cin2
	OPENBLAS_NUM_THREADS=2 ./xzcblat2 < zin2
endif
endif

all3: xscblat3 xdcblat3 xccblat3 xzcblat3
ifndef CROSS
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./xscblat3 < sin3
	OMP_NUM_THREADS=2 ./xdcblat3 < din3
	OMP_NUM_THREADS=2 ./xccblat3 < cin3
	OMP_NUM_THREADS=2 ./xzcblat3 < zin3
else
	OPENBLAS_NUM_THREADS=2 ./xscblat3 < sin3
	OPENBLAS_NUM_THREADS=2 ./xdcblat3 < din3
	OPENBLAS_NUM_THREADS=2 ./xccblat3 < cin3
	OPENBLAS_NUM_THREADS=2 ./xzcblat3 < zin3
endif

all3_3m: xzcblat3_3m xccblat3_3m
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./xccblat3_3m < cin3_3m
	OMP_NUM_THREADS=2 ./xzcblat3_3m < zin3_3m
else
	OPENBLAS_NUM_THREADS=2 ./xccblat3_3m < cin3_3m
	OPENBLAS_NUM_THREADS=2 ./xzcblat3_3m < zin3_3m
endif
endif




clean ::
	rm -f x*

FLDFLAGS = $(FFLAGS:-fPIC=) $(LDFLAGS)
ifeq ($(USE_OPENMP), 1)
ifeq ($(F_COMPILER), GFORTRAN)
ifeq ($(C_COMPILER), CLANG)
CEXTRALIB = -lomp
endif
endif
endif

# Single real
xscblat1: $(stestl1o) c_sblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xscblat1 c_sblat1.o $(stestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xscblat2: $(stestl2o) c_sblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xscblat2 c_sblat2.o $(stestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xscblat3: $(stestl3o) c_sblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xscblat3 c_sblat3.o $(stestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
# Double real
xdcblat1: $(dtestl1o) c_dblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xdcblat1 c_dblat1.o $(dtestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xdcblat2: $(dtestl2o) c_dblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xdcblat2 c_dblat2.o $(dtestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xdcblat3: $(dtestl3o) c_dblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xdcblat3 c_dblat3.o $(dtestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)

# Single complex
xccblat1: $(ctestl1o) c_cblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xccblat1 c_cblat1.o $(ctestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xccblat2: $(ctestl2o) c_cblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xccblat2 c_cblat2.o $(ctestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xccblat3: $(ctestl3o) c_cblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xccblat3 c_cblat3.o $(ctestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)

xccblat3_3m: $(ctestl3o_3m) c_cblat3_3m.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xccblat3_3m c_cblat3_3m.o $(ctestl3o_3m) $(LIB) $(EXTRALIB) $(CEXTRALIB)

# Double complex
xzcblat1: $(ztestl1o) c_zblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xzcblat1 c_zblat1.o $(ztestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xzcblat2: $(ztestl2o) c_zblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xzcblat2 c_zblat2.o $(ztestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xzcblat3: $(ztestl3o) c_zblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xzcblat3 c_zblat3.o $(ztestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)


xzcblat3_3m: $(ztestl3o_3m) c_zblat3_3m.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xzcblat3_3m c_zblat3_3m.o $(ztestl3o_3m) $(LIB) $(EXTRALIB) $(CEXTRALIB)


include $(TOPDIR)/Makefile.tail

=== utest/Makefile ===
UTEST_CHECK = 1
TOPDIR	= ..

override TARGET_ARCH=
override TARGET_MACH=

UTESTBIN=openblas_utest

.PHONY : all
.NOTPARALLEL : all run_test $(UTESTBIN)

include $(TOPDIR)/Makefile.system

OBJS=utest_main.o test_amax.o test_rotmg.o test_axpy.o test_dotu.o test_dsdot.o test_swap.o test_rot.o
#test_rot.o test_swap.o test_axpy.o test_dotu.o test_dsdot.o test_fork.o

ifneq ($(NO_LAPACK), 1)
OBJS += test_potrs.o
ifneq ($(NO_CBLAS), 1)
ifneq ($(NO_LAPACKE), 1)
OBJS += test_kernel_regress.o
endif
endif
endif

#this does not work with OpenMP nor with native Windows or Android threads
# FIXME TBD if this works on OSX, SunOS, POWER and zarch
ifndef USE_OPENMP
ifeq ($(OSNAME), $(filter $(OSNAME),Linux CYGWIN_NT))
OBJS += test_fork.o
endif
endif

ifeq ($(C_COMPILER), PGI)
OBJS = utest_main2.o
endif

all : run_test

$(UTESTBIN): $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ ../$(LIBNAME) $(EXTRALIB) $(FEXTRALIB)

run_test: $(UTESTBIN)
ifndef CROSS
	./$(UTESTBIN)
endif

clean:
	-rm -f *.o $(UTESTBIN)

libs:

=== driver/others/Makefile ===
TOPDIR	= ../..
include ../../Makefile.system

COMMONOBJS	 = memory.$(SUFFIX) xerbla.$(SUFFIX) c_abs.$(SUFFIX) z_abs.$(SUFFIX) openblas_set_num_threads.$(SUFFIX) openblas_get_num_threads.$(SUFFIX) openblas_get_num_procs.$(SUFFIX) openblas_get_config.$(SUFFIX) openblas_get_parallel.$(SUFFIX) openblas_error_handle.$(SUFFIX) openblas_env.$(SUFFIX)

#COMMONOBJS	+= slamch.$(SUFFIX) slamc3.$(SUFFIX) dlamch.$(SUFFIX)  dlamc3.$(SUFFIX)

ifdef SMP
COMMONOBJS	+= blas_server.$(SUFFIX) divtable.$(SUFFIX) blasL1thread.$(SUFFIX)
ifndef NO_AFFINITY
COMMONOBJS	+= init.$(SUFFIX)
endif
endif

# COMMONOBJS	+=  info.$(SUFFIX)

ifeq ($(DYNAMIC_ARCH), 1)
ifeq ($(ARCH),arm64)
COMMONOBJS	+=  dynamic_arm64.$(SUFFIX)
else
ifeq ($(ARCH),power)
COMMONOBJS	+=  dynamic_power.$(SUFFIX)
else
ifeq ($(ARCH),zarch)
COMMONOBJS += dynamic_zarch.$(SUFFIX)
else
COMMONOBJS	+=  dynamic.$(SUFFIX)
endif
endif
endif
else
COMMONOBJS	+=  parameter.$(SUFFIX)
endif

ifdef EXPRECISION
COMMONOBJS	+= x_abs.$(SUFFIX) qlamch.$(SUFFIX) qlamc3.$(SUFFIX)
endif

ifdef QUAD_PRECISION
COMMONOBJS	+= addx.$(SUFFIX) mulx.$(SUFFIX)
endif

ifeq ($(OSNAME), CYGWIN_NT)
ifeq ($(C_COMPILER), PGI)
# COMMONOBJS	+= __builtin_stinit.$(SUFFIX)
endif
endif

ifdef USE_CUDA
COMMONOBJS	+= cuda_init.$(SUFFIX)
endif

ifdef FUNCTION_PROFILE
COMMONOBJS	+= profile.$(SUFFIX)
endif

LIBOTHERS = libothers.$(LIBSUFFIX)

ifeq ($(CORE), PPC440)
MEMORY = memory_qalloc.c
endif

ifndef MEMORY
MEMORY = memory.c
endif

ifeq ($(USE_OPENMP), 1)
BLAS_SERVER = blas_server_omp.c
else
ifeq ($(OSNAME), WINNT)
BLAS_SERVER = blas_server_win32.c
endif
ifeq ($(OSNAME), CYGWIN_NT)
BLAS_SERVER = blas_server_win32.c
endif
ifeq ($(OSNAME), Interix)
BLAS_SERVER = blas_server_win32.c
endif
endif

ifndef BLAS_SERVER
BLAS_SERVER = blas_server.c
endif

ifeq ($(DYNAMIC_ARCH), 1)
ifeq ($(ARCH),arm64)
HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) dynamic_arm64.$(SUFFIX)
else
ifeq ($(ARCH),power)
HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) dynamic_power.$(SUFFIX)
else
ifeq ($(ARCH),zarch)
HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) dynamic_zarch.$(SUFFIX)
else
HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) dynamic.$(SUFFIX)
endif
endif
endif
else
HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) parameter.$(SUFFIX)
endif

xerbla.$(SUFFIX) : xerbla.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

dynamic.$(SUFFIX) : dynamic.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

dynamic.$(PSUFFIX) : dynamic.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

parameter.$(SUFFIX) : parameter.c ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

init.$(SUFFIX) : init.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

profile.$(SUFFIX) : profile.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

memory.$(SUFFIX) : $(MEMORY) ../../common.h ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

blas_server.$(SUFFIX) : $(BLAS_SERVER) ../../common.h ../../common_thread.h ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_set_num_threads.$(SUFFIX) : openblas_set_num_threads.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_get_num_threads.$(SUFFIX) : openblas_get_num_threads.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_get_num_procs.$(SUFFIX) : openblas_get_num_procs.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_get_config.$(SUFFIX) : openblas_get_config.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_get_parallel.$(SUFFIX) : openblas_get_parallel.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_error_handle.$(SUFFIX) : openblas_error_handle.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_env.$(SUFFIX) : openblas_env.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

blasL1thread.$(SUFFIX) : blas_l1_thread.c ../../common.h ../../common_thread.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

cuda_init.$(SUFFIX) : cuda_init.c
	$(CUCC) $(COMMON_OPT) -I$(TOPDIR) $(CUFLAGS) -DCNAME=$(*F) -c $< -o $(@F)

c_abs.$(SUFFIX) : abs.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

z_abs.$(SUFFIX) : abs.c
	$(CC) $(CFLAGS) -c -DDOUBLE $< -o $(@F)

x_abs.$(SUFFIX) : abs.c
	$(CC) $(CFLAGS) -c -DXDOUBLE $< -o $(@F)

slamch.$(SUFFIX) : lamch.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

dlamch.$(SUFFIX) : lamch.c
	$(CC) $(CFLAGS) -c -DDOUBLE $< -o $(@F)

qlamch.$(SUFFIX) : lamch.c
	$(CC) $(CFLAGS) -c -DXDOUBLE $< -o $(@F)

slamc3.$(SUFFIX) : lamc3.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

dlamc3.$(SUFFIX) : lamc3.c
	$(CC) $(CFLAGS) -c -DDOUBLE $< -o $(@F)

qlamc3.$(SUFFIX) : lamc3.c
	$(CC) $(CFLAGS) -c -DXDOUBLE $< -o $(@F)

divtable.$(SUFFIX) : divtable.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

__builtin_stinit.$(SUFFIX) : $(ARCH)/builtin_stinit.S
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

addx.$(SUFFIX) : $(ARCH)/addx.c
	$(CC) $(CFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

mulx.$(SUFFIX) : $(ARCH)/mulx.c
	$(CC) $(CFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

xerbla.$(PSUFFIX) : xerbla.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

parameter.$(PSUFFIX) : parameter.c ../../param.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

init.$(PSUFFIX) : init.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

profile.$(PSUFFIX) : profile.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

memory.$(PSUFFIX) : $(MEMORY) ../../common.h ../../param.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

blas_server.$(PSUFFIX) : $(BLAS_SERVER) ../../common.h ../../common_thread.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

blasL1thread.$(PSUFFIX) : blas_l1_thread.c ../../common.h ../../common_thread.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

cuda_init.$(PSUFFIX) : cuda_init.c
	$(CUCC) $(COMMON_OPT) -I$(TOPDIR) $(CUFLAGS) -DCNAME=$(*F) -c $< -o $(@F)

c_abs.$(PSUFFIX) : abs.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

z_abs.$(PSUFFIX) : abs.c
	$(CC) $(PFLAGS) -c -DDOUBLE $< -o $(@F)

x_abs.$(PSUFFIX) : abs.c
	$(CC) $(PFLAGS) -c -DXDOUBLE $< -o $(@F)

slamch.$(PUFFIX) : lamch.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

dlamch.$(PUFFIX) : lamch.c
	$(CC) $(PFLAGS) -c -DDOUBLE $< -o $(@F)

qlamch.$(PUFFIX) : lamch.c
	$(CC) $(PFLAGS) -c -DXDOUBLE $< -o $(@F)

slamc3.$(PUFFIX) : lamc3.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

dlamc3.$(PUFFIX) : lamc3.c
	$(CC) $(PFLAGS) -c -DDOUBLE $< -o $(@F)

qlamc3.$(PUFFIX) : lamc3.c
	$(CC) $(PFLAGS) -c -DXDOUBLE $< -o $(@F)

divtable.$(PSUFFIX) : divtable.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

__builtin_stinit.$(PPSUFFIX) : $(ARCH)/builtin_stinit.S
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

addx.$(PSUFFIX) : $(ARCH)/addx.c
	$(CC) $(PFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

mulx.$(PSUFFIX) : $(ARCH)/mulx.c
	$(CC) $(PFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

info.$(SUFFIX) : info.c info.h ../../common.h ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)


hpl   : override CFLAGS += -DHPL
hpl_p : override CFLAGS += -DHPL

include $(TOPDIR)/Makefile.tail

=== lapack/lauu2/Makefile ===
TOPDIR	= ../..
include ../../Makefile.system

SBLASOBJS = slauu2_U.$(SUFFIX) slauu2_L.$(SUFFIX)
DBLASOBJS = dlauu2_U.$(SUFFIX) dlauu2_L.$(SUFFIX)
QBLASOBJS = qlauu2_U.$(SUFFIX) qlauu2_L.$(SUFFIX)
CBLASOBJS = clauu2_U.$(SUFFIX) clauu2_L.$(SUFFIX)
ZBLASOBJS = zlauu2_U.$(SUFFIX) zlauu2_L.$(SUFFIX)
XBLASOBJS = xlauu2_U.$(SUFFIX) xlauu2_L.$(SUFFIX)

slauu2_U.$(SUFFIX) : lauu2_U.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

slauu2_L.$(SUFFIX) : lauu2_L.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

dlauu2_U.$(SUFFIX) : lauu2_U.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

dlauu2_L.$(SUFFIX) : lauu2_L.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

qlauu2_U.$(SUFFIX) : lauu2_U.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

qlauu2_L.$(SUFFIX) : lauu2_L.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

clauu2_U.$(SUFFIX) : zlauu2_U.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

clauu2_L.$(SUFFIX) : zlauu2_L.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

zlauu2_U.$(SUFFIX) : zlauu2_U.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

zlauu2_L.$(SUFFIX) : zlauu2_L.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

xlauu2_U.$(SUFFIX) : zlauu2_U.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

xlauu2_L.$(SUFFIX) : zlauu2_L.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

slauu2_U.$(PSUFFIX) : lauu2_U.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

slauu2_L.$(PSUFFIX) : lauu2_L.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

dlauu2_U.$(PSUFFIX) : lauu2_U.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

dlauu2_L.$(PSUFFIX) : lauu2_L.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

qlauu2_U.$(PSUFFIX) : lauu2_U.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

qlauu2_L.$(PSUFFIX) : lauu2_L.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

clauu2_U.$(PSUFFIX) : zlauu2_U.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

clauu2_L.$(PSUFFIX) : zlauu2_L.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

zlauu2_U.$(PSUFFIX) : zlauu2_U.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

zlauu2_L.$(PSUFFIX) : zlauu2_L.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

xlauu2_U.$(PSUFFIX) : zlauu2_U.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

xlauu2_L.$(PSUFFIX) : zlauu2_L.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

include ../../Makefile.tail

=== lapack/potf2/Makefile ===
TOPDIR	= ../..
include ../../Makefile.system

SBLASOBJS = spotf2_U.$(SUFFIX) spotf2_L.$(SUFFIX)
DBLASOBJS = dpotf2_U.$(SUFFIX) dpotf2_L.$(SUFFIX)
QBLASOBJS = qpotf2_U.$(SUFFIX) qpotf2_L.$(SUFFIX)
CBLASOBJS = cpotf2_U.$(SUFFIX) cpotf2_L.$(SUFFIX)
ZBLASOBJS = zpotf2_U.$(SUFFIX) zpotf2_L.$(SUFFIX)
XBLASOBJS = xpotf2_U.$(SUFFIX) xpotf2_L.$(SUFFIX)

spotf2_U.$(SUFFIX) : potf2_U.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

spotf2_L.$(SUFFIX) : potf2_L.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

dpotf2_U.$(SUFFIX) : potf2_U.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

dpotf2_L.$(SUFFIX) : potf2_L.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

qpotf2_U.$(SUFFIX) : potf2_U.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

qpotf2_L.$(SUFFIX) : potf2_L.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

cpotf2_U.$(SUFFIX) : zpotf2_U.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

cpotf2_L.$(SUFFIX) : zpotf2_L.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

zpotf2_U.$(SUFFIX) : zpotf2_U.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

zpotf2_L.$(SUFFIX) : zpotf2_L.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

xpotf2_U.$(SUFFIX) : zpotf2_U.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

xpotf2_L.$(SUFFIX) : zpotf2_L.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

spotf2_U.$(PSUFFIX) : potf2_U.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

spotf2_L.$(PSUFFIX) : potf2_L.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -UDOUBLE $< -o $(@F)

dpotf2_U.$(PSUFFIX) : potf2_U.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

dpotf2_L.$(PSUFFIX) : potf2_L.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DDOUBLE $< -o $(@F)

qpotf2_U.$(PSUFFIX) : potf2_U.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

qpotf2_L.$(PSUFFIX) : potf2_L.c
	$(CC) -c $(PFLAGS) -UCOMPLEX -DXDOUBLE $< -o $(@F)

cpotf2_U.$(PSUFFIX) : zpotf2_U.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

cpotf2_L.$(PSUFFIX) : zpotf2_L.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -UDOUBLE $< -o $(@F)

zpotf2_U.$(PSUFFIX) : zpotf2_U.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

zpotf2_L.$(PSUFFIX) : zpotf2_L.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DDOUBLE $< -o $(@F)

xpotf2_U.$(PSUFFIX) : zpotf2_U.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

xpotf2_L.$(PSUFFIX) : zpotf2_L.c
	$(CC) -c $(PFLAGS) -DCOMPLEX -DXDOUBLE $< -o $(@F)

include ../../Makefile.tail

=== debian/changelog ===
openblas (0.3.8+ds-1ubuntu0.20.04.1) focal; urgency=medium

  * Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP: #1860601)
    also see #961725 and #722252

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 02 Jun 2020 10:55:55 +0000

=== debian/control ===
Source: openblas
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>,
           Mo Zhou <cdluminate@gmail.com>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-exec,
               gfortran,
               liblapack-dev (>= 3.8.0-5~),
               liblapack64-dev (>= 3.8.0-5~) [amd64 arm64 ppc64el ppc64 kfreebsd-amd64 mips64el sparc64 s390x],
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/openblas
Vcs-Git: https://salsa.debian.org/science-team/openblas.git
Homepage: https://github.com/xianyi/OpenBLAS
Rules-Requires-Root: no

# 32-bit indexing version

Package: libopenblas0
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: metapackages
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenblas0-pthread | libopenblas0-openmp | libopenblas0-serial,
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Description: Optimized BLAS (linear algebra) library (meta)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian

Package: libopenblas0-pthread
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so.3,
          liblapack.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, pthread)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=1 USE_OPENMP=0 INTERFACE64=0

Package: libopenblas0-openmp
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so.3,
          liblapack.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, openmp)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=1 USE_OPENMP=1 INTERFACE64=0

Package: libopenblas0-serial
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so.3,
          liblapack.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, serial)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=0 USE_OPENMP=0 INTERFACE64=0

Package: libopenblas-base
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: oldlibs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenblas0,
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Description: Optimized BLAS (linear algebra) library (transitional)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 This is a transitional dummy package, which can be safely removed.

Package: libopenblas-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: metapackages
Depends: libopenblas0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
         libopenblas-pthread-dev | libopenblas-openmp-dev | libopenblas-serial-dev,
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Description: Optimized BLAS (linear algebra) library (dev, meta)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.

Package: libopenblas-pthread-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libdevel
Depends: libopenblas0-pthread (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Provides: libblas.so,
          liblapack.so
Description: Optimized BLAS (linear algebra) library (dev, pthread)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.
 .
 Configuration: USE_THREAD=1 USE_OPENMP=0 INTERFACE64=0

Package: libopenblas-openmp-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libdevel
Depends: libopenblas0-openmp (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Provides: libblas.so,
          liblapack.so
Description: Optimized BLAS (linear algebra) library (dev, openmp)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.
 .
 Configuration: USE_THREAD=1 USE_OPENMP=1 INTERFACE64=0

Package: libopenblas-serial-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libdevel
Depends: libopenblas0-serial (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Provides: libblas.so,
          liblapack.so
Description: Optimized BLAS (linear algebra) library (dev, serial)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.
 .
 Configuration: USE_THREAD=0 USE_OPENMP=0 INTERFACE64=0

# 64-bit indexing version

Package: libopenblas64-0
Architecture: amd64 arm64 kfreebsd-amd64 ppc64 ppc64el mips64el sparc64 s390x
Multi-Arch: same
Section: metapackages
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenblas64-0-pthread | libopenblas64-0-openmp | libopenblas64-0-serial,
Description: Optimized BLAS (linear algebra) library (shared lib, 64bit, meta)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 This metapackage provides a 64-bit indexing version.

Package: libopenblas64-0-pthread
Architecture: amd64 arm64 kfreebsd-amd64 ppc64 ppc64el mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Provides: libblas64.so.3,
          liblapack64.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, 64bit, pthread)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=1 USE_OPENMP=0 INTERFACE64=1

Package: libopenblas64-0-openmp
Architecture: amd64 arm64 kfreebsd-amd64 ppc64 ppc64el mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Provides: libblas64.so.3,
          liblapack64.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, 64bit, openmp)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
SOVER := 0
SRCS := $(filter-out debian $(FLAVORS), $(wildcard ./*))

MAKE_OPTIONS := NO_LAPACKE=1 NO_AFFINITY=1 NO_WARMUP=1 CFLAGS="$(CPPFLAGS) $(CFLAGS)" FFLAGS="$(FFLAGS)"

# Avoid having -O2 automatically added (especially for DEB_BUILD_OPTIONS=noopt)
MAKE_OPTIONS += COMMON_OPT=

# Build generic package with hardcoded max number of threads of 64
GENERIC_OPTIONS := NUM_THREADS=64

# Architectures with dynamic arch selection
# TARGET=GENERIC is needed to avoid FTBFS when CPU detection fails (see #923607)
ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386 ppc64el
ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
	GENERIC_OPTIONS += DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 TARGET=GENERIC
endif

# For other archs, there is no dynamic arch selection. To avoid selecting a
# target based on the buildd hardware, we enforce a generic-enough target.

# We cannot use the ARMv7 profile on armhf, because it requires a 32-register FP unit.
# See kernel/arm/KERNEL.ARMv7: it loads some *_vfpv3.S files, which use 32 registers.
# Also, it FTBFS if GCC flag -mvfpv3 is removed (see arm-gcc-flags.patch), because GCC
# refuses asm files with 32 FP registers in that case.
# Issue discussed in https://github.com/xianyi/OpenBLAS/issues/388
# See also debian/patches/arm-gcc-flags.patch which is related.
TARGET_OPTION_armhf     = TARGET=ARMV6
# We do not use DYNAMIC_ARCH selection on powerpc because it only works for
# POWER6 and above
TARGET_OPTION_powerpc   = TARGET=PPCG4
TARGET_OPTION_mips64el  = TARGET=SICORTEX
# We do not use DYNAMIC_ARCH selection on ppc64 because it fails to build.
# See https://buildd.debian.org/status/fetch.php?pkg=openblas&arch=ppc64&ver=0.3.6%2Bds-1&stamp=1562602383&raw=0
# POWER6 is the most generic arch that compiles on ppc64
TARGET_OPTION_ppc64     = TARGET=POWER6
TARGET_OPTION_sparc64   = TARGET=SPARC
TARGET_OPTION_s390x     = TARGET=ZARCH_GENERIC
GENERIC_OPTIONS += $(TARGET_OPTION_$(DEB_HOST_ARCH))

export DEB_LDFLAGS_MAINT_STRIP="-Wl,-Bsymbolic-functions"

ifeq (,$(filter custom,$(DEB_BUILD_OPTIONS)))
	# Generic package
	MAKE_OPTIONS += $(GENERIC_OPTIONS)
else
	# Custom package: leave the arch detection to OpenBLAS, and optimize for the current CPU
	export DEB_CFLAGS_MAINT_APPEND := -march=native -mtune=native
	export DEB_FFLAGS_MAINT_APPEND := -march=native -mtune=native
endif

# Flavors: 64-bit array indexing is invalid for 32-bit machines.
ifeq (64,$(DEB_HOST_ARCH_BITS))
	FLAVORS = $(SOVER)-pthread $(SOVER)-openmp $(SOVER)-serial 64-$(SOVER)-pthread 64-$(SOVER)-openmp 64-$(SOVER)-serial
else
	FLAVORS = $(SOVER)-pthread $(SOVER)-openmp $(SOVER)-serial
endif
# FLAVORS =  # XXX: Define your target configurations here if you are going to build customized packages
FLAGS_0-pthread    := USE_THREAD=1 USE_OPENMP=0 INTERFACE64=0 LIBPREFIX=libopenblas   FCOMMON_OPT=-frecursive
FLAGS_0-openmp     := USE_THREAD=1 USE_OPENMP=1 INTERFACE64=0 LIBPREFIX=libopenblas   FCOMMON_OPT=-frecursive
FLAGS_0-serial     := USE_THREAD=0 USE_OPENMP=0 INTERFACE64=0 LIBPREFIX=libopenblas   FCOMMON_OPT=-frecursive
FLAGS_64-0-pthread := USE_THREAD=1 USE_OPENMP=0 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fdefault-integer-8'
FLAGS_64-0-openmp  := USE_THREAD=1 USE_OPENMP=1 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fdefault-integer-8'
FLAGS_64-0-serial  := USE_THREAD=0 USE_OPENMP=0 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fdefault-integer-8'

# Priority values in the Update-Alternatives mechanism.
# O,P,S stands for openmp, pthread, serial respectively
UAPRI_O = 95
UAPRI_P = 100
UAPRI_S = 90


%:
	dh $@

override_dh_auto_configure: $(addprefix config_, $(FLAVORS))
	:

config_%:
	# shared object packages
	mkdir $*; cp -r $(SRCS) $*/;
	for i in install postinst prerm shlibs; do \
		if test -z "$$(echo $* | grep 64)"; then \
			cp debian/libopenblas$(SOVER)-XXX.$$i debian/libopenblas$*.$$i; \
		else \
			cp debian/libopenblas64-$(SOVER)-XXX.$$i debian/libopenblas$*.$$i; \
		fi; \
		sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
			-e "s/@SUBDIR@/openblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))/g" \
			-e "s/@FLAVOR@/$*/g" \
			debian/libopenblas$*.$$i; \
		if test -n "$$(echo $* | grep pthread)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_P)/g" debian/libopenblas$*.$$i; \
		elif test -n "$$(echo $* | grep openmp)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_O)/g" debian/libopenblas$*.$$i; \
		else \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_S)/g" debian/libopenblas$*.$$i; \
		fi; \
	done;
	# devel packages
	for i in install links postinst prerm dirs; do \
		if test -z "$$(echo $* | grep 64)"; then \
			cp debian/libopenblas-XXX-dev.$$i debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		else \
			cp debian/libopenblas64-XXX-dev.$$i debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		fi; \
		sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
			-e "s/@SUBDIR@/openblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))/g" \
			-e "s/@FLAVOR@/$*/g" \
			debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		if test -n "$$(echo $* | grep pthread)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_P)/g" debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		elif test -n "$$(echo $* | grep openmp)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_O)/g" debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		else \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_S)/g" debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		fi; \
	done;

override_dh_auto_build: 
	for target in $(addprefix build_, $(FLAVORS)); do \
		$(MAKE) -f debian/rules $$target || exit 1; done

build_0-pthread:
	$(MAKE) -C 0-pthread libs netlib shared $(MAKE_OPTIONS) $(FLAGS_0-pthread)
	$(MAKE) -C 0-pthread/interface shared-blas-lapack $(MAKE_OPTIONS) $(FLAGS_0-pthread)
build_64-0-pthread:
	$(MAKE) -C 64-0-pthread libs netlib shared $(MAKE_OPTIONS) $(FLAGS_64-0-pthread)
	$(MAKE) -C 64-0-pthread/interface shared-blas64-lapack64 $(MAKE_OPTIONS) $(FLAGS_64-0-pthread)
build_0-openmp:
	$(MAKE) -C 0-openmp libs netlib shared $(MAKE_OPTIONS) $(FLAGS_0-openmp)
	$(MAKE) -C 0-openmp/interface shared-blas-lapack $(MAKE_OPTIONS) $(FLAGS_0-openmp)
build_64-0-openmp:
	$(MAKE) -C 64-0-openmp libs netlib shared $(MAKE_OPTIONS) $(FLAGS_64-0-openmp)
	$(MAKE) -C 64-0-openmp/interface shared-blas64-lapack64 $(MAKE_OPTIONS) $(FLAGS_64-0-openmp)
build_0-serial:
	$(MAKE) -C 0-serial libs netlib shared $(MAKE_OPTIONS) $(FLAGS_0-serial)
	$(MAKE) -C 0-serial/interface shared-blas-lapack $(MAKE_OPTIONS) $(FLAGS_0-serial)
build_64-0-serial:
	$(MAKE) -C 64-0-serial libs netlib shared $(MAKE_OPTIONS) $(FLAGS_64-0-serial)
	$(MAKE) -C 64-0-serial/interface shared-blas64-lapack64 $(MAKE_OPTIONS) $(FLAGS_64-0-serial)
# XXX: why doesn't this work??
#build_%:
#   $(MAKE) -C $* $(MAKE_OPTIONS) $(FLAGS_$*)
#   $(MAKE) -C $*/interface $(MAKE_OPTIONS) $(FLAGS_$*)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	for target in $(addprefix test_, $(FLAVORS)); do \
		$(MAKE) -f debian/rules $$target || exit 1; done
endif

test_0-pthread:
	$(MAKE) -C 0-pthread tests $(MAKE_OPTIONS) $(FLAGS_0-pthread)
test_64-0-pthread:
	$(MAKE) -C 64-0-pthread tests $(MAKE_OPTIONS) $(FLAGS_64-0-pthread)
test_0-openmp:
	$(MAKE) -C 0-openmp tests $(MAKE_OPTIONS) $(FLAGS_0-openmp)
test_64-0-openmp:
	$(MAKE) -C 64-0-openmp tests $(MAKE_OPTIONS) $(FLAGS_64-0-openmp)
test_0-serial:
	$(MAKE) -C 0-serial tests $(MAKE_OPTIONS) $(FLAGS_0-serial)
test_64-0-serial:
	$(MAKE) -C 64-0-serial tests $(MAKE_OPTIONS) $(FLAGS_64-0-serial)
# XXX: why cannot this work?
#test_%:
#	$(MAKE) -C $* test $(MAKE_OPTIONS) $(FLAGS_$(*))

override_dh_auto_install:
	for target in $(addprefix install_, $(FLAVORS)); do \
